#!/usr/bin/perl -w

# Author   : Benoit PAPILLAULT <benoit.papillault@free.fr>
# Creation : 17/03/2001

# Dump all buffer contents from a first to a last URB.

$offset = 0;

# the number of the first URB to be included in the dump
$first_URB = 12; #  12

# the number of the last URB to be included in the dump
$last_URB  = 139; # 139

$active    = 0;

open (BIN, ">buf.bin");

while (<>) {
#    print $_;
    if (/URB ([0-9]+) going down/) {
	if ($1 eq $first_URB) {
	    print "++ begin\n";
	    $active = 1;
	}
    }
    if (/URB ([0-9]+) coming back/) {
	if ($1 eq $last_URB) {
	    print "++ end\n";
	    $active = 0;
	}
    }

    if ($active && /[0-9]+  [0-9]+:[0-9]+:[0-9]+( )+[0-9a-f]+: ([0-9a-f ]+)/) {
#	print "-$_->$2<-\n";
	@list = split / /, $2;
	$idx = 0;

	# printf("/* 0x%x */ ", $offset);

	foreach $byte (@list) {
	    if ($idx == 0) {
		print "  ";
	    }

	    print "0x$byte, ";
	    $bb = chr (hex ($byte));
	    print BIN $bb;

	    $offset ++;
	    $idx ++;

	    if ($idx == 8) {
		print "\n";
		$idx = 0;
	    }
	}
    }
}

close BIN;
