#!/usr/bin/perl -w

$bTransferLength = 0;
$bGetData = 0;
$idx = 0;

while (<>) 
{
	if (/URB_FUNCTION_BULK_OR_INTERRUPT_TRANSFER/) {
		$bTransferLength = 1;
	}

	if ($bTransferLength && /TransferBufferLength[ ]*=[ ]*([0-9a-f]*)/) {
		$len = hex($1);

		if (($len % 53) == 0 && $len > 0) {
			print "ok, len = $len, $_\n";
			$bGetData = 1;

			$idx ++;
			open OUT,">pkt${idx}.log";
		}
	}

	if ($bGetData && /[0-9a-f]*: ([0-9a-f ]*)/) {
		$data = $1;
		print "data : $data";

		while ( $data =~ /([0-9a-f]+)/g) {
			print "pkt $idx, hexa : $1\n";
			$byte = hex($1);
			print OUT chr($byte);
		}
	}

	if (/UrbLink/) {
		print "closing\n";
		close OUT;
		$bTransferLength = 0;
		$bGetData = 0;
	}
}





